import xml.etree.ElementTree as ET
import string
import sys
import math
import uuid

def get_id():
    return uuid.uuid4().hex

tree = ET.parse(sys.argv[1])
root = tree.getroot()
rootChildren = list(root.iter('layer'))
for child in rootChildren:
    if(child.attrib['type'] == "region"):
        for item in list(child):
            if(item.attrib['name'] == "bline" and len(list(list(item)[0])) >= 4 ):    
                #print(len(list(child)))
                x_points = []
                y_points = []
                for vertex in list(list(item)[0]):
                    x = list(list(list(list(vertex)[0])[0])[0])[0].text
                    x_points.append(float(x))
                    y = list(list(list(list(vertex)[0])[0])[0])[1].text
                    y_points.append(float(y))
                RectVertices = []
                RectVertices.append([max(y_points), min(x_points)])
                RectVertices.append([min(y_points), max(x_points)])
                solution = [ (RectVertices[0][0] + RectVertices[1][0]) / 2, (RectVertices[0][1] + RectVertices[1][1]) / 2 ]
                if(solution[0] != 0):
                    slopeOfLine = solution[1] / solution[0]
                    distance = math.sqrt(math.pow(solution[0], 2) + math.pow(solution[1], 2))
                    for childItem in list(child):
                        if(childItem.attrib['name'] == "bline"):
                            for vertex in list(list(childItem)[0]):
                                list(list(list(list(vertex)[0])[0])[0])[0].text = str(float(list(list(list(list(vertex)[0])[0])[0])[0].text) - solution[1])
                                list(list(list(list(vertex)[0])[0])[0])[1].text = str(float(list(list(list(list(vertex)[0])[0])[0])[1].text) - solution[0])
                        if(childItem.attrib['name'] == "origin"):
                            list(list(childItem)[0])[0].text = str(solution[1])
                            list(list(childItem)[0])[1].text = str(solution[0])
    # else:
    #     #print(child.attrib['type'])

tr2ee = ET.ElementTree(root)
with open(sys.argv[1], "wb") as fh:
    tr2ee.write(fh)